/**
 * HTTP代理服务器
 * @author Hoverlees http://www.hoverlees.com/blog/?p=1337
 */

#include "proxy_client_session.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "proxy_utils.h"

ProxyClientSession* proxy_client_create(){
	ProxyClientSession* r=(ProxyClientSession*) calloc(sizeof(ProxyClientSession),1);
	if(r!=NULL){
		r->type=2;
	}
	return r;
}

void proxy_client_destroy(ProxyClientSession* session){
	free(session);
}

EpollSession* proxy_client_connect(EpollServer* server,EpollSession* session,char* host,char* request,int requestLen){
	SOCKET clientSocket;
	EpollSession* csession;
	ProxyClientSession* ps;
	int port=80;
	int i,len;
	char* t;
	len=strlen(host);
	t=host;
	for(i=0;i<len;i++){
		if(*t==':'){
			*t=0;
			t++;
			port=atoi(t);
			break;
		}
		t++;
	}
	
	clientSocket=socket(AF_INET,SOCK_STREAM,0);
	if(clientSocket<=0) {
		return NULL;
	}
	csession=epoll_server_register(session->server,clientSocket);
	if(csession==NULL){
		closesocket(clientSocket);
		return NULL;
	}
	if(!hostname_to_ip(host,&csession->address)){
		closesocket(clientSocket);
		return NULL;
	}
	fcntl(clientSocket,F_SETFL,fcntl(clientSocket,F_GETFL,0)|O_NONBLOCK);
	
	csession->address.sin_family=AF_INET;
	csession->address.sin_port=htons(port);
	connect(clientSocket,(struct sockaddr *)&csession->address,sizeof(struct sockaddr_in));
	
	ps=proxy_client_create();
	ps->proxySession=session;
	ps->type=2;
	csession->userData=ps;
	
	epoll_server_send_data(csession,request,requestLen);
	//epoll_server_send_eof(csession);
	return csession;
}

void proxy_client_modify_request(char* request,int requestLen,char* host){
	char *t;
	int len;
	
	strncpy(strcasestr(request,"keep-alive"),"close     ",10);
	
	t=strstr(request,host);
	len=0;
	while(*t!=' ' && len<10){
		len++;
		t--;
	}
	t++;
	len=len-1+strlen(host);
	
	while(*t!=0){
		*t=t[len];
		if(t[len]==0) break;
		t++;
	}
	
	/*
	while(len>0){
		*t=' ';
		t++;
		len--;
	}
	*/
}