/**
 * HTTP代理服务器
 * @author Hoverlees http://www.hoverlees.com/blog/?p=1337
 */

#ifndef __HOVERLEES_PROXY_CONFIG_H
#define __HOVERLEES_PROXY_CONFIG_H

#include "proxy_http_request.h"
#include "../lua/lua.h"
#include "../lua/lualib.h"
#include "../lua/lauxlib.h"

typedef struct{
	char bindIP[32];
	int bindPort;
	int mapNum;
	lua_CFunction on_request;
	lua_State* runtime;
}ProxyConfig;


extern void proxy_log(char* str);

ProxyConfig* proxy_read_config(const char* filename);
void proxy_free_config(ProxyConfig* config);
int proxy_request_callback(ProxyConfig* config,ProxyHttpRequest* request);
#endif