/**
 * HTTP代理服务器
 * @author Hoverlees http://www.hoverlees.com/blog/?p=1337
 */

#ifndef __HOVERLEES_PROXY_HTTP_H
#define __HOVERLEES_PROXY_HTTP_H


typedef struct _ProxyHttpHeaderNode{
	char* key;
	char* value;
	struct _ProxyHttpHeaderNode* next;
	
}ProxyHttpHeaderNode;

typedef struct {
	int status;
	ProxyHttpHeaderNode* headers;
	ProxyHttpHeaderNode* lastHeader;
	char* method;
	char* uri;
	char* requestBody;
	char* rawRequest;
	int rawRequestBufferSize;
	int rawRequestLen;
	int requestBodyLen;
	
	int ppos;
	int pstart1;
	int pend1;
	int pstart2;
	int pend2;
}ProxyHttpRequest;


ProxyHttpRequest* proxy_http_request_create();
void proxy_http_request_destroy(ProxyHttpRequest* request);
int proxy_http_request_add_buffer(ProxyHttpRequest* request,char* buffer,int len);
char* proxy_http_request_get_header(ProxyHttpRequest* request,const char* key);
#endif