/**
 * HTTP代理服务器
 * @author Hoverlees http://www.hoverlees.com/blog/?p=1337
 */

#include "proxy_rc4.h"
#include <stdio.h>

void proxy_rc4_init(unsigned char* sbox,char* key,int keyLen){
	int i,j;
	unsigned char t;
	for(i=0;i<256;i++)
		sbox[i]=i;
	for(i=j=0;i<256;i++){
		j=(j+key[i%keyLen]+sbox[i])%256;
		t=sbox[i];
		sbox[i]=sbox[j];
		sbox[j]=t;
	}
}

void proxy_rc4_crypt(unsigned char* sbox,const char* in,unsigned char* out,int inLen){
	int i,j,k;
	unsigned char t;
	i=j=0;
	while(i<inLen){
		i=(i+1)%256;
		j=(j+sbox[i])%256;
		t=sbox[i];
		sbox[i]=sbox[j];
		sbox[j]=t;
		k=(sbox[i]+sbox[j])%256;
		out[i-1]=sbox[k]^in[i-1];
	}
}

void proxy_rc4_print(char* data,int len){
	int i;
	for(i=0;i<len;i++){
		printf("%02X",data[i]&0xff);
	}
	printf("\n");
}