/**
 * HTTP代理服务器
 * @author Hoverlees http://www.hoverlees.com/blog/?p=1337
 */

#include <stdio.h>

#include "proxy_config.h"
#include "proxy_rc4.h"
#include "proxy_epoll_server.h"
#include "proxy_session.h"
#include "proxy_utils.h"
#include "proxy_client_session.h"

ProxyConfig* config;

void on_connect(EpollSession* session){
	ProxySession* psession;
	psession=proxy_session_create();
	if(psession==NULL){
		epoll_server_send_eof(session);
	}
	else session->userData=psession;
}
void on_recieve(EpollSession* session,char* buffer,int len){
	ProxyHttpHeaderNode* p;
	ProxySession* psession;
	ProxyClientSession* csession;
	EpollSession* tsession;
	char *t;
	int i;
	
	psession=(ProxySession*)session->userData;
	if(psession->type==1){ //proxy
		//printf("proxy read\n");
		i=proxy_http_request_add_buffer(psession->request,buffer,len);
		if(i==1){
			if(!proxy_request_callback(config,psession->request)){
				epoll_server_send_eof(session);
			}
			/////////////
			t=proxy_http_request_get_header(psession->request,"Host");
			if(t){
				psession->request->rawRequest[psession->request->rawRequestLen]=0;
				proxy_client_modify_request(psession->request->rawRequest,psession->request->rawRequestLen,t);
				tsession=proxy_client_connect(session->server,session,t,psession->request->rawRequest,psession->request->rawRequestLen);
				if(tsession==NULL){
					epoll_server_send_eof(session);
				}
				else{
					psession->clientSession=tsession;
				}
			}
			else epoll_server_send_eof(session);
			///////////////
		}
		else if(i==-1){
			epoll_server_send_eof(session);
		}
	}
	else{ //client
		//printf("client read\n");
		csession=(ProxyClientSession*) psession;
		if(csession->proxySession!=NULL){
			epoll_server_send_copy(csession->proxySession,buffer,len);
		}
		else{
			epoll_server_send_eof(session);
		}
	}
}
void on_disconnect(EpollSession* session){
	ProxySession* psession;
	ProxyClientSession* csession;
	psession=(ProxySession*)session->userData;
	if(psession->type==1){ //proxy
		//printf("proxy close\n");
		if(psession->clientSession!=NULL){
			csession=(ProxyClientSession*)psession->clientSession->userData;
			if(csession!=NULL){
				csession->proxySession=NULL;
			}
			//epoll_server_send_eof(psession->clientSession);
		}
		proxy_session_destory(psession);
	}
	else{ //client
		csession=(ProxyClientSession*) psession;
		//printf("client close.\n");
		if(csession->proxySession!=NULL){
			psession=(ProxySession*)csession->proxySession->userData;
			if(psession!=NULL){
				psession->clientSession=NULL;
			}
			epoll_server_send_eof(csession->proxySession);
		}
		proxy_client_destroy(csession);
	}
}
void main(int argc ,char* argv){
	EpollServer server;
	config=proxy_read_config("config.lua");
	if(config){
		if(epoll_server_create(&server,config->bindIP,config->bindPort)){
			server.onConnect=on_connect;
			server.onRecieve=on_recieve;
			server.onDisconnect=on_disconnect;
			epoll_server_start(&server);
		}
	}
	proxy_free_config(config);
}